*include ..\include.src.bas\Ver.bas

*If(ndime==2)
*WarningBox Info: For exporting Transport 2D & 2D Axisymetry & 3D modeling.
*EndIf
// --------------------------
//  This is a TRANSPORT task 
// --------------------------
TASK name "*GenData(TaskName)"

*Set Var Axisym=0
*If(ndime==2 && GenData(Axi_symmetric_task,Int)==1)
*Set Var Axisym=1
*EndIf
*#
Title "*GenData(Title)"
*If(Axisym==1)
 space axisymmetric
*Else
 dimension  *ndime
*EndIf

*If(nmats(Int)==0)
*MessageBox error: You don't have assigned Materials
*EndIf

*# // zapis jednotek
*include ..\include.src.bas\WriteUnits.bas

*Set Var DefaultSpace=3
*include ..\include.src.bas\initialVariablesSetting.bas
*include ..\include.src.bas\Materials.bas
*Set Var AddTranspAnalysis=60

*include ..\include.src.bas\WriteJoints.bas

*loop materials
*If(strcmp(MatProp(Material_Prototype),"CCModelBaXi94")==0 || strcmp(MatProp(Material_Prototype),"CCSandwicKubinaCombinedMaterial")==0 || strcmp(MatProp(Material_Prototype),"CCSandwicKubina")==0)
*#Format "%i"
SELECTION "$N$Mat*MatNum" LIST /** *MatProp(0) **/ *tcl(NodesWithMaterial *MatProp(0)) ;

*#Format "%i"
 NODAL SETTING SELECTION "$N$Mat*MatNum"
      GENERATE_TYPE *MatNum(Int)
   CONST *MatProp(Temperature_CONST,real)	COEFF_X *MatProp(Temperature_COEFF_X,real)	COEFF_Y *MatProp(Temperature_COEFF_Y,real)	COEFF_Z *MatProp(Temperature_COEFF_Z,real)	GENERATE_TEMP
*If(strcmp(MatProp(Initial_Water_State),"Humidity")==0)
   CONST *MatProp(Humidity_CONST,real)	COEFF_X *MatProp(Humidity_COEFF_X,real)	COEFF_Y *MatProp(Humidity_COEFF_Y,real)	COEFF_Z *MatProp(Humidity_COEFF_Z,real)	GENERATE_H
*Else
*# If(strcmp(MatProp(Initial_Water_State),"Moisture")==0)
   CONST *MatProp(Moisture_Content_CONST,real)	COEFF_X *MatProp(Moisture_Content_COEFF_X,real)	COEFF_Y *MatProp(Moisture_Content_COEFF_Y,real)	COEFF_Z *MatProp(Moisture_Content_COEFF_Z,real)	GENERATE_W
*endif   
   ;
*EndIf
*End materials
*#
*Set elems(All)
*#
*Set Var CurrentType=-1
*Set Var PreviousType=0
*Set Var PreviousIndex=0
*Set Var warnQuadHex=0
*Set Var warnQuadTetra=0
*Set Var warnShell=0
*# Set Var oMaxIndexElemGroups=0
*# Set Var oMinIndexElemGroups=90000
*Set Var groupID=-1
*Set Var ElemConstrActiv=0
*Set Var oldElemsMat=0
*#
// Element group definition
*Set Var nshells=0
*Set Var nbeam=0
*loop elems
*#If(ElemsType!=1)
*# 	1=Linear, toto je samostatna podminka, ze se nebudou Vypisovat Trussove prvky
*Set Var MaterialType=0
*#
*include ..\include.src.bas\InLoopElementCheck.bas
*include ..\include.src.bas\CurrentElementGroupID.bas
*#
*If(CurrentType==SignMinus && groupID<=SignMinus)
// *CurrentType *groupID *ElemsMat *ElemsNum *ElemsNnode ;
*# If(ElemsType==3 || ElemsType==2)
*# MessageBox error: You can't use 2D elements(on Surfaces) in 3D. This problem solve: Meshing->Mesh criteria->No Mesh->Surfaces (please select all)
*# Else
*tcl(TK_Signal *ElemsNum)

ElemsNum    *ElemsNum *ElemsConec
ElemsMat    *ElemsMat
CurrentType *CurrentType
ElemsType *ElemsType
ElemsNnode *ElemsNnode

*MessageBox error: You don't have assigned Material *ElemsMat at Element *ElemsNum
*# EndIf
*# *WarningBox Warning: You don't have assigned Material for Element ID ElemsNum(Int) *ElemsNum(Int)
*EndIf
*If(PreviousType!=CurrentType || PreviousIndex!=groupID)
*#
*#include ..\include.src.bas\ElementType3.bas
*tcl(TK_WriteElementType2Activity *ElemsMatProp(0) *ElemsType *ElemsNnode *AddTranspAnalysis *groupID)
*#
 ELEMENT GROUP ID *groupID TYPE *groupID /** *ElemsMatProp(0)/*ElemsMatProp(1) - *CurrentType **/ MATERIAL *ElemsMat GEOMETRY  *ElemsMat
 ELEMENT INCIDENCES
// *ElemsMatProp(0) *ElemsMatProp(1)
*EndIf
*#
*include ..\include.src.bas\ElementConectivities.bas
*#
*#EndIf
*End elems

*# pro deskove prvky je nyni nutne zapsat PREPARE_CALCULATION flag
*Set Var ElemConstrActiv=0
*If(nshells>0||nbeam>0)
*#tcl(TK_WriteShellPrepareCalculation *Cond(Assign_material) *ElemsType *ElemsNnode *AddTranspAnalysis *groupID)
*include ..\include.src.bas\ShellPrepareCalculation.bas
*EndIf

*# Set elems(Linear)
*# Set Var nrods=nelem(Linear)
*# If(nrods>0)
*# // Vypis tycovych prvku primo Do inpu - neni automaticky zajisteno spojeni s konstrukci - experimentalni provoz
*# // pozor spojeni s konstrukci musi zajistit uzivatel(koncove uzly prutu musi byt soucasne uzly dalsi konstrukce) 
*# *Set Var oMaxReinfGroups=-1
*# *include ..\include.src.bas\Write_Clasic_Bar_Element.bas
*# *#
*# // Vypis Embedded_Reinforcement generovanych prvku - spojeni s konstrukci zajisteno samo
*# *include ..\include.src.bas\Write_Trusses_and_Cables.bas
*# // End block of Reinforcement
*# EndIf 

*Set elems(All)
// Writing SELECTIONs
*#include ..\include.src.bas\TransportElementSelection.bas
*include ..\include.src.bas\LoadElementSelection.bas
*#
*#Set Var ApplyInSubIncrement=2
*Set Var ApplyInSubIncrement=0
*If(strcmp(GenData(Calculation_Analysis),"SandwichTemperature3D")!=0)
// veskere Master nodes v jednom listu a veskere Slave nodes ve druhem listu
*include ..\include.src.bas\MasterSlaveSelectionNodes.bas

// Master nodes a Slave nodes v samostatnych listech
*include ..\include.src.bas\Contact_for_Surface.bas
*EndIf
*#
*IntFormat "%10i"
*Set Var oiSel=988800
*#
	Function ID *oiSel NAME "Load function#*oiSel" TYPE "CCMultiLinearFunction" XVALUES 0.0  YVALUES 1.0 ;
	MACRO_JOINT COORDINATES *oiSel 0.0 0.0 0.0
	SELECTION "all_nodes#*oiSel" GENERATE NODES WITHIN  DISTANCE 1000000.0 FROM  POINT MACRO NODES *oiSel Execute ;

*#
*# writing information For Maximal Monitored values
*# begin block of Maximal Monitors
*include ..\include.src.bas\MaxMonitor_for.bas
//	-> block of MaxMonitors  #*nMaxMonitor
*#
*# begin block of Clasic Monitors
*include ..\include.src.bas\Clasic_Monitor_for_nodes.bas
//	-> block of Monitors  #*nMonitor
 ; 
//----------------------------------------------------------------------------
//                          Default Setting of Method
//----------------------------------------------------------------------------
SET *GenData(Method)
*If(strcmp(GenData(Method),"Arc-Length")==0)
 CONSISTENTLY_LINEARISED
 ARC_LENGTH_VARIABLE_CONSERVATIVE_1/4
 LOAD_DISPLACEMENT_RATIO       0.200
 LOADING_DISPLACEMENT_RATIO_CONSTANT
 REFERENCE_NUMBER_OF_ITERATIONS 5
SET ARC_LENGTH_RESET_STEP_LENGTH
*EndIf
SET Displacement Error *GenData(Displacement_Error)
SET Residual Error     *GenData(Residual_Error)
SET Absolute Residual Error *GenData(Absolute_Residual_Error)
SET Energy Error       *GenData(Energy_Error)
SET Iteration limit    *GenData(Iteration_limit)
SET Optimize width     *GenData(Optimize_width)
SET *GenData(Stiffness_type)
*If(strcmp(GenData(Assemble_Stiffness_Matrix),"Each_Iteration")==0)
SET Full_NR
*else
SET Modified_NR
*EndIf
*#If(GenData(Line-Search_Method,Int)==1)
*If(0)
SET Line-Search
SET *GenData(Line_Search_With_Iterations)
SET Unbalanced_Energy_Limit *GenData(Unbalanced_Energy_Limit)
SET Line_Search_Iteration_Limit *GenData(Line_Search_Iteration_Limit)
SET Minimum_Eta *GenData(Minimum_Eta)
SET Maximum_Eta *GenData(Maximum_Eta)
Set SOLVER *GenData(Solver)
*EndIf

*If(GenData(Conditional_Break_Criteria,Int)==1)
*include ..\include.src.bas\Advanced_set_method.bas
*EndIf

//----------------------------------------------------------------------------\\
//                                 Load step definitions                      \\
//----------------------------------------------------------------------------\\
/**
CURRENT_TRANSIENT_TIME of GenData is replaced by INTERVAL_STARTING_TIME of 1. Interval
*tcl(Set_Starting_Time1Interval_To_Current_TimeGenData )
**/
SET TRANSIENT TIME CURRENT *GenData(CURRENT_TRANSIENT_TIME)
SET TRANSIENT TIME_INTEGRATION *GenData(TIME_INTEGRATION_OF_TRANSIENT)
*If(strcmp(GenData(TIME_INTEGRATION_OF_TRANSIENT),"CRANK_NICHOLSON")==0)
THETA *GenData(THETA_OF_CRANK_NICHOLSON)
*Else
NEWMARK BETA *GenData(NEWMARK_BETA_OF_ADAMS_BASHFORTH)
NEWMARK GAMA *GenData(NEWMARK_GAMA_OF_ADAMS_BASHFORTH)
*EndIf

*If(GenData(EXPORT_TRANSPORT_RESULTS,Int)==1) Then
HISTORY OVERWRITE EXPORT GEOMETRY "*GenData(EXPORT_GEOMETRY_TO)"
RESULTS  "*GenData(EXPORT_RESULTS_TO)"
*EndIf

/** Load case combination **/
Output Record Length 9000
// Apply load case 1 and etc. on the model
*Set Var AddingConstruction=3000
*Set Var StepIndex=0
*Set Var IntervalIndex=0
*Set Var IntervalIndex2=0
*Set elems(All)

*Set Var oflagElmIDMerge=1
*If(GenData(Show_Surface_Loads_In_Post-Processor,Int)==0)
*Set Var oflagElmIDMerge=0
*EndIf

*loop intervals
*Set Var IntervalIndex2=Operation(IntervalIndex2+1)
*Set Var krokVIntervalu=Operation(0+1)
*If(IntvData(Interval_Is_Active,real)==1)
*#
*Set Var IntervalIndex=Operation(IntervalIndex+1)
*Set Var ApplyInSubIncrement=1
// begin of block For Load Case
*include ..\include.src.bas\WriteLoadCase_for_Transport.bas
*#
*Set Var multip=Operation(IntvData(INTERVAL_Multiplier,Real)/IntvData(Number_of_LOAD_STEPs,Real))

*Set Var LastInteractMater=0
*Set Var EActivity=0
*Set Var ElemConstrActiv=1

*If(strcmp(GenData(Calculation_Analysis),"SandwichTemperature3D")!=0)
*include ..\include.src.bas\ElementActivity.bas
*EndIf

*If(IntvData(User_Solution_Parameters,Int)==1)
//----------------------------------------------------------------------------\\
//                      Setting of Method in INTERVAL *IntervalIndex             \\
//----------------------------------------------------------------------------\\
SET *IntvData(Method)
*If(strcmp(IntvData(Method),"Arc-Length")==0)
 CONSISTENTLY_LINEARISED
 ARC_LENGTH_VARIABLE_CONSERVATIVE_1/4
 LOAD_DISPLACEMENT_RATIO       0.200
 LOADING_DISPLACEMENT_RATIO_CONSTANT
 REFERENCE_NUMBER_OF_ITERATIONS 5
SET ARC_LENGTH_RESET_STEP_LENGTH
*EndIf
SET Displacement Error *IntvData(Displacement_Error)
SET Residual Error     *IntvData(Residual_Error)
SET Absolute Residual Error *IntvData(Absolute_Residual_Error)
SET Energy Error       *IntvData(Energy_Error)
SET Iteration limit    *IntvData(Iteration_limit)
SET Optimize width     *IntvData(Optimize_width)
SET *IntvData(Stiffness_type)
*If(strcmp(IntvData(Assemble_Stiffness_Matrix),"Each_Iteration")==0)
SET Full_NR
*else
SET Modified_NR
*EndIf
*#If(IntvData(Line-Search_Method,Int)==1)
*If(0)
SET Line-Search
SET *IntvData(Line_Search_With_Iterations)
SET Unbalanced_Energy_Limit *IntvData(Unbalanced_Energy_Limit)
SET Line_Search_Iteration_Limit *IntvData(Line_Search_Iteration_Limit)
SET Minimum_Eta *IntvData(Minimum_Eta)
SET Maximum_Eta *IntvData(Maximum_Eta)
*EndIf
Set SOLVER *IntvData(Solver)
*EndIf
//----------------------------------------------------------------------------- 
//  DEFINITION and EXECUTION OF INTERVAL *IntervalIndex Name:*IntvData(LOAD_NAME)
//----------------------------------------------------------------------------- 
/** Number of steps in Interval *IntervalIndex = *IntvData(Number_of_LOAD_STEPs,Int) **/

*include ..\include.src.bas\WriteTransportStep.bas
*Set Var IsIntervalWithFire=0
*Else


// GiD Interval number *IntervalIndex2 is disabled
*Set Var IntervalIndex=Operation(IntervalIndex+1)
*EndIf

*End Intervals

*include ..\include.src.bas\MonitorOutput.bas

*include ..\include.src.bas\StepInfo.bas

/** End of file **/
