# p is a list of 3 coordinates, and dp the list of dx dy dz
# sample use: CreateVolume1 {3 4 2} {3 1 2}

proc Create_Macroelement1Volume {px py pz dx dy dz } {
    set p2x [expr $px + $dx]
    set p2y [expr $py + $dy]
    set p2z [expr $pz + $dz]

    set OldCreateAlwaysNewPoint [GiD_Info variables CreateAlwaysNewPoint]
    # set variable value to create a new point, also if exists another in the same location
    GiD_Process escape escape escape escape utilities variables CreateAlwaysNewPoint 1
    # create a temporary layer. The new rectangle will be created in this new layer to use
    # in fact must find a non-existent layername but...
    set currentlayer [lindex [GiD_Info project] 3]
    
    # dynamic number of layer    
#   set oMacroelementCount [expr [GiD_Info Geometry MaxNumVolumes]+1]
    set oMacroelementCount [GiD_AccessValue get  gendata  "MacroelementCount"]
    set layer_name "Generation_$oMacroelementCount"

     set existing_layers [GiD_Info layers]
     set nlayers [llength $existing_layers]
#     WarnWinText "existing_layers=[llength $existing_layers], $existing_layers"
     set exist_tmp 0
     for {set i 0} {$i < $nlayers} {set i [expr $i+1]} {
#	     WarnWinText "[lindex $existing_layers $i],$layer_name"
	    set ext_layer [lindex $existing_layers $i]
	    if {$ext_layer == $layer_name} {
	    	set exist_tmp 1
	    }
     }
     if {$exist_tmp == 0} {
     	GiD_Process escape escape escape escape view layers new $layer_name escape
     } else {
     	WarnWinText "exist_tmp=$exist_tmp, existing_layers=$existing_layers"
     }     
    GiD_Process escape escape escape escape view layers touse $layer_name escape
    GiD_Process escape escape escape escape Geometry Create Object \
	    Rectangle $px $py $pz $p2x $p2y $pz escape escape

    GiD_Process escape escape escape escape Utilities Copy Surfaces \
	    Duplicate DoExtrude Volumes MaintainLayers Translation \
	    $px $py $pz $px $py $p2z layer:$layer_name

    GiD_Process escape escape escape escape view layers entities $currentlayer \
	    lowerentities volumes layer:$layer_name escape
    GiD_Process escape escape escape escape view layers touse $currentlayer

    #delete temporary layer (used only to select his entities)
    GiD_Process escape escape escape escape view layers delete $layer_name escape

    #restore old variable value
    GiD_Process escape escape escape escape utilities variables \
	    CreateAlwaysNewPoint $OldCreateAlwaysNewPoint escape escape
}

proc positionWindow { w } {
    wm geometry $w +300+300
}

proc CreateUserMacroelement { } {

    set w .cMacroelement
    catch {destroy $w}
    toplevel $w
    wm title $w [= "Create User Macroelement"]
    positionWindow $w

    frame  $w.principal
    label  $w.principal.label1 -text "px:" -width 5 -anchor w
    entry  $w.principal.entry1 -width 5 -borderwidth 1 -insertborderwidth 1

    label  $w.principal.label2 -text "py:" -width 5 -anchor w
    entry  $w.principal.entry2 -width 5 -borderwidth 1 -insertborderwidth 1

    label  $w.principal.label3 -text "pz:" -width 5 -anchor w
    entry  $w.principal.entry3 -width 5 -borderwidth 1 -insertborderwidth 1

    frame  $w.incremental
    label  $w.incremental.label1 -text "dx:" -width 5 -anchor w
    entry  $w.incremental.entry1 -width 5 -borderwidth 1 -insertborderwidth 1

    label  $w.incremental.label2 -text "dy:" -width 5 -anchor w
    entry  $w.incremental.entry2 -width 5 -borderwidth 1 -insertborderwidth 1

    label  $w.incremental.label3 -text "dz:" -width 5 -anchor w
    entry  $w.incremental.entry3 -width 5 -borderwidth 1 -insertborderwidth 1

    frame    $w.buttons
    pack     $w.buttons -side bottom -fill x -pady 3m
    button   $w.buttons.dismiss -text [= "Close"] -command "destroy $w"

    proc CreateMacroelementCmd { w } {
	set px [$w.principal.entry1   get]
	set py [$w.principal.entry2   get]
	set pz [$w.principal.entry3   get]
	set dx [$w.incremental.entry1 get]
	set dy [$w.incremental.entry2 get]
	set dz [$w.incremental.entry3 get]
	Create_Macroelement1Volume $px $py $pz $dx $dy $dz
	GiD_Process zoom frame escape escape escape escape
    }
    button $w.buttons.code -text [= "Apply"] -command "CreateMacroelementCmd $w"

    pack     $w.buttons.code $w.buttons.dismiss -side left -expand 1
    pack     $w.principal.label1   $w.principal.entry1   $w.principal.label2 \
	    $w.principal.entry2   $w.principal.label3   $w.principal.entry3 \
	    -side left
    pack     $w.incremental.label1 $w.incremental.entry1 $w.incremental.label2 \
	    $w.incremental.entry2 $w.incremental.label3 $w.incremental.entry3 -side left
    pack     $w.principal   -side top -fill x
    pack     $w.incremental -side top -fill x

    focus $w.principal.entry1
    bind $w <Return> "CreateMacroelementCmd $w"
    bind $w <Escape> "destroy $w"
}

#CreateUserMacroelement
